about summary refs log tree commit diff
path: root/tests/substitutes2.sh
diff options
context:
space:
mode:
authorEelco Dolstra <e.dolstra@tudelft.nl>2004-06-24T12·56+0000
committerEelco Dolstra <e.dolstra@tudelft.nl>2004-06-24T12·56+0000
commit8052aef4866e236ef0bb5d5675bbae330abb9b9b (patch)
tree149cae936f60724b4ccdb8714bff97950dc3ddf7 /tests/substitutes2.sh
parent66c7f347591c0c4e26e018672c487a3090e36e5e (diff)
* A test for multiple and/or failing substitutes.
Diffstat (limited to 'tests/substitutes2.sh')
-rw-r--r--tests/substitutes2.sh40
1 files changed, 40 insertions, 0 deletions
diff --git a/tests/substitutes2.sh b/tests/substitutes2.sh
new file mode 100644
index 0000000000..33bae3238f
--- /dev/null
+++ b/tests/substitutes2.sh
@@ -0,0 +1,40 @@
+# Instantiate.
+storeExpr=$($TOP/src/nix-instantiate/nix-instantiate substitutes.nix)
+echo "store expr is $storeExpr"
+
+# Find the output path.
+outPath=$($TOP/src/nix-store/nix-store -qvvvvv "$storeExpr")
+echo "output path is $outPath"
+
+# Instantiate the substitute program.
+subExpr=$($TOP/src/nix-instantiate/nix-instantiate substituter.nix)
+echo "store expr is $subExpr"
+
+# Instantiate the failing substitute program.
+subExpr2=$($TOP/src/nix-instantiate/nix-instantiate substituter2.nix)
+echo "store expr is $subExpr2"
+
+regSub() {
+    (echo $1 && echo $2 && echo "/substituter" && echo 3 && echo $outPath && echo Hallo && echo Wereld) | $TOP/src/nix-store/nix-store --substitute
+}
+
+# Register a fake successor, and a substitute for it.
+suc=$NIX_STORE_DIR/aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa-s.store
+regSub $suc $subExpr
+$TOP/src/nix-store/nix-store --successor $storeExpr $suc
+
+# Register a failing substitute for it (it takes precedence).
+regSub $suc $subExpr2
+
+# Register a substitute for the output path.
+regSub $outPath $subExpr
+
+# Register another substitute for the output path.  This one will
+# produce other output. 
+regSub $outPath $subExpr2
+
+
+$TOP/src/nix-store/nix-store -rvvvvv "$storeExpr"
+
+text=$(cat "$outPath"/hello)
+if test "$text" != "Foo Hallo Wereld"; then exit 1; fi